Attribute VB_Name = "Module1"
'SGI Image Viewer (*.RGB, *.BW) for Visual Basic 6.0
'
'Copyright 2003 by Dmitry Brant, All Rights Reserved.

'Version 1.1, Last modified 04-27-2000
'
'me@dmitrybrant.com
'
'http://www.dmitrybrant.com


'This program supports the SGI specification as described below:

'- This program fully supports alpha channels for compressed
'  and uncompressed images.

'IMPORTANT: The routines for decoding uncompressed images have
'not been tested yet, because I couldn't find a sample image
'which was not compressed. If you have one, please send it.

'Feel free to make improvements or optimizations to the program.
'If you do, please tell me or show me what you have done.

'This program is FREEWARE. Use freely, but give me credit
'where credit is due. (this program is NOT in the
'public domain). If you will use this source code in
'your software, the copyright notice stated above
'must be included in your source code and/or in the
'Help/About box of your program.

'The SOURCE CODE of this program, or portions of it, may not
'be redistributed, either by itself or in a compilation
'package, without express authorization from the author.

'ALL PRODUCT NAMES MENTIONED IN THIS SOFTWARE ARE TRADEMARKS
'OR REGISTERED TRADEMARKS OF THEIR RESPECTIVE OWNERS.

'THIS SOFTWARE IS DISTRIBUTED "AS IS". THE SOFTWARE IS
'DISTRIBUTED WITH NO WARRANTY, EIHER EXPRESSED
'OR IMPLIED, INCLUDING, BY WAY OF EXAMPLE THE IMPLIED
'WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
'PURPOSE. THE AUTHOR WILL NOT BE LIABLE FOR DATA LOSS, DAMAGES,
'LOSS OF PROFITS OR ANY OTHER KIND OF LOSS RESULTING FROM THE
'USE OR MISUSE OF THIS SOFTWARE.

Option Explicit
DefInt A-Z

Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long

Public Sub DoRGB(FName As String, FObject As Object)
    Dim i As Integer, j As Integer, k As Integer, ptr As Integer
    Dim r As Integer, g As Integer, b As Integer, a As Integer
    Dim X As Integer, Y As Integer, theHdc As Long
    Dim Compression As Integer, BytesPerComp As Integer
    Dim Dimension As Integer, FWidth As Long, FHeight As Long
    Dim ZSize As Integer, PixMin As Long, PixMax As Long
    Dim ColorMap As Long, d As Long, bpos As Long
    Dim TabLen As Long, LineCount As Integer, str1 As String
    
    On Error GoTo ErrorTrap0
    
    Open FName For Binary As #1
    i = GetWord
    If i <> 474 Then
        MsgBox "Header doesn't check out: " + Str(i), vbCritical, "Error"
        Close #1
        Exit Sub
    End If
    Compression = GetByte
    If Compression <> 0 And Compression <> 1 Then
        MsgBox "Unsupported compression flag: " + Str(Compression), vbCritical, "Error"
        Close #1
        Exit Sub
    End If
    BytesPerComp = GetByte
    If BytesPerComp <> 1 Then
        MsgBox "Unsupported bytes per component: " + Str(BytesPerComp), vbCritical, "Error"
        Close #1
        Exit Sub
    End If
    Dimension = GetWord
    If Dimension <> 1 And Dimension <> 2 And Dimension <> 3 Then
        MsgBox "Unsupported Dimension: " + Str(Dimension), vbCritical, "Error"
        Close #1
        Exit Sub
    End If
    
    theHdc = FObject.hdc
    FWidth = GetWord
    FHeight = GetWord
    ZSize = GetWord
    PixMin = GetDword
    PixMax = GetDword
    
    FObject.Width = FWidth
    FObject.Height = FHeight
    
    str1 = "    "
    Get #1, , str1
    str1 = Space(80)
    Get #1, , str1
    Form1.Caption = "RgbView - " + str1
    ColorMap = GetDword
    str1 = Space(404)
    Get #1, , str1
    'the Header is now complete

    If Compression = 1 Then
        TabLen = FHeight * ZSize
        ReDim Offsets(0 To TabLen) As Long
        'get the offset table
        For i = 0 To TabLen
            Offsets(i) = GetDword
        Next i
        Seek #1, Offsets(0) + 1
    End If
    
    If Compression = 1 Then
        Select Case ZSize
        Case 1
            For Y = FHeight - 1 To 0 Step -1
                X = 0
                Do
                    i = GetByte
                    j = i And &H7F
                    If j = 0 Then Exit Do
                    If i And &H80 Then
                        For k = 1 To j
                            r = GetByte
                            SetPixel theHdc, X, Y, RGB(r, r, r)
                            X = X + 1
                        Next k
                    Else
                        r = GetByte
                        FObject.Line (X, Y)-Step(j, 0), RGB(r, r, r)
                        X = X + j
                    End If
                Loop
                If Y Mod 16 = 0 Then FObject.Refresh: DoEvents
            Next Y
        Case 3
            LineCount = 0
            ReDim ScanlineR(0 To FWidth - 1) As Byte
            ReDim ScanlineG(0 To FWidth - 1) As Byte
            ReDim ScanlineB(0 To FWidth - 1) As Byte
            For Y = FHeight - 1 To 0 Step -1
                Seek #1, Offsets(LineCount) + 1
                ptr = 0
                Do      'get channel 1 scanline
                    i = GetByte
                    j = i And &H7F
                    If j = 0 Then Exit Do
                    If i And &H80 Then
                        For k = 1 To j
                            ScanlineR(ptr) = GetByte
                            ptr = ptr + 1
                        Next k
                    Else
                        r = GetByte
                        For k = 1 To j
                            ScanlineR(ptr) = r
                            ptr = ptr + 1
                        Next k
                    End If
                Loop
                Seek #1, Offsets(LineCount + FHeight) + 1
                ptr = 0
                Do      'get channel 2 scanline
                    i = GetByte
                    j = i And &H7F
                    If j = 0 Then Exit Do
                    If i And &H80 Then
                        For k = 1 To j
                            ScanlineG(ptr) = GetByte
                            ptr = ptr + 1
                        Next k
                    Else
                        r = GetByte
                        For k = 1 To j
                            ScanlineG(ptr) = r
                            ptr = ptr + 1
                        Next k
                    End If
                Loop
                Seek #1, Offsets(LineCount + 2 * FHeight) + 1
                ptr = 0
                Do      'get channel 3 scanline
                    i = GetByte
                    j = i And &H7F
                    If j = 0 Then Exit Do
                    If i And &H80 Then
                        For k = 1 To j
                            ScanlineB(ptr) = GetByte
                            ptr = ptr + 1
                        Next k
                    Else
                        r = GetByte
                        For k = 1 To j
                            ScanlineB(ptr) = r
                            ptr = ptr + 1
                        Next k
                    End If
                Loop
                For X = 0 To FWidth - 1
                    r = ScanlineR(X)
                    g = ScanlineG(X)
                    b = ScanlineB(X)
                    SetPixel theHdc, X - 1, Y, RGB(r, g, b)
                Next X
                LineCount = LineCount + 1
                If Y Mod 16 = 0 Then FObject.Refresh: DoEvents
            Next Y
            Erase ScanlineR
            Erase ScanlineG
            Erase ScanlineB
        Case 4
            LineCount = 0
            ReDim ScanlineR(0 To FWidth - 1) As Byte
            ReDim ScanlineG(0 To FWidth - 1) As Byte
            ReDim ScanlineB(0 To FWidth - 1) As Byte
            ReDim ScanlineA(0 To FWidth - 1) As Byte
            For Y = FHeight - 1 To 0 Step -1
                Seek #1, Offsets(LineCount) + 1
                ptr = 0
                Do      'get channel 1 scanline
                    i = GetByte
                    j = i And &H7F
                    If j = 0 Then Exit Do
                    If i And &H80 Then
                        For k = 1 To j
                            ScanlineR(ptr) = GetByte
                            ptr = ptr + 1
                        Next k
                    Else
                        r = GetByte
                        For k = 1 To j
                            ScanlineR(ptr) = r
                            ptr = ptr + 1
                        Next k
                    End If
                Loop
                Seek #1, Offsets(LineCount + FHeight) + 1
                ptr = 0
                Do      'get channel 2 scanline
                    i = GetByte
                    j = i And &H7F
                    If j = 0 Then Exit Do
                    If i And &H80 Then
                        For k = 1 To j
                            ScanlineG(ptr) = GetByte
                            ptr = ptr + 1
                        Next k
                    Else
                        r = GetByte
                        For k = 1 To j
                            ScanlineG(ptr) = r
                            ptr = ptr + 1
                        Next k
                    End If
                Loop
                Seek #1, Offsets(LineCount + 2 * FHeight) + 1
                ptr = 0
                Do      'get channel 3 scanline
                    i = GetByte
                    j = i And &H7F
                    If j = 0 Then Exit Do
                    If i And &H80 Then
                        For k = 1 To j
                            ScanlineB(ptr) = GetByte
                            ptr = ptr + 1
                        Next k
                    Else
                        r = GetByte
                        For k = 1 To j
                            ScanlineB(ptr) = r
                            ptr = ptr + 1
                        Next k
                    End If
                Loop
                Seek #1, Offsets(LineCount + 3 * FHeight) + 1
                ptr = 0
                Do      'get channel 4 scanline
                    i = GetByte
                    j = i And &H7F
                    If j = 0 Then Exit Do
                    If i And &H80 Then
                        For k = 1 To j
                            ScanlineA(ptr) = GetByte
                            ptr = ptr + 1
                        Next k
                    Else
                        r = GetByte
                        For k = 1 To j
                            ScanlineA(ptr) = r
                            ptr = ptr + 1
                        Next k
                    End If
                Loop
                For X = 0 To FWidth - 1
                    r = ScanlineR(X)
                    g = ScanlineG(X)
                    b = ScanlineB(X)
                    a = ScanlineA(X)
                    SetPixelA theHdc, X - 1, Y, r, g, b, a
                Next X
                LineCount = LineCount + 1
                If Y Mod 16 = 0 Then FObject.Refresh: DoEvents
            Next Y
            Erase ScanlineR
            Erase ScanlineG
            Erase ScanlineB
            Erase ScanlineA
        End Select
    Else
        Select Case ZSize
        Case 1
            For Y = FHeight - 1 To 0 Step -1
                For X = 0 To FWidth - 1
                    i = GetByte
                    SetPixel theHdc, X, Y, RGB(i, i, i)
                Next X
                If Y Mod 16 = 0 Then FObject.Refresh: DoEvents
            Next Y
        Case 3
            LineCount = 0
            ReDim scan1(0 To FWidth * FHeight - 1) As Byte
            ReDim scan2(0 To FWidth * FHeight - 1) As Byte
            ReDim scan3(0 To FWidth * FHeight - 1) As Byte
            Get #1, , scan1
            Get #1, , scan2
            Get #1, , scan3
            For Y = 0 To FHeight - 1
                For X = 0 To FWidth - 1
                    r = scan1(Y * FWidth + X)
                    g = scan2(Y * FWidth + X)
                    b = scan3(Y * FWidth + X)
                    SetPixel theHdc, X, FHeight - Y, RGB(r, g, b)
                Next X
                If Y Mod 16 = 0 Then FObject.Refresh: DoEvents
            Next Y
            Erase scan1
            Erase scan2
            Erase scan3
        End Select
    End If
    Close #1
    Erase Offsets
    Exit Sub
ErrorTrap0:
    Close #1
    MsgBox "There was an error reading the file:" + vbCrLf + Error, vbCritical, "Error"
End Sub

Function GetByte() As Integer
    Dim a As Byte
    Get #1, , a
    GetByte = a
End Function

Function GetWord() As Long
    Dim a As Byte
    Dim d As Long
    Get #1, , a: d = d + CLng(a) * 256
    Get #1, , a: d = d + CLng(a)
    GetWord = d
End Function

Function GetDword() As Long
    Dim a As Byte
    Dim d As Long
    Get #1, , a: d = CLng(a) * 16777216
    Get #1, , a: d = d + CLng(a) * 65536
    Get #1, , a: d = d + CLng(a) * 256
    Get #1, , a: d = d + CLng(a)
    GetDword = d
End Function

'Set an alpha-pixel
Sub SetPixelA(dc As Long, x1 As Integer, y1 As Integer, r1 As Integer, g1 As Integer, b1 As Integer, a1 As Integer)
    Dim col2 As Long, r As Integer, g As Integer, b As Integer, diff As Integer
    col2 = GetPixel(dc, x1, y1)
    b = (col2 \ 65536) And &HFF
    g = (col2 \ 256) And &HFF
    r = col2 And &HFF
    diff = CLng(b1 - b) * a1 / 256
    b = b + diff
    diff = CLng(g1 - g) * a1 / 256
    g = g + diff
    diff = CLng(r1 - r) * a1 / 256
    r = r + diff
    SetPixel dc, x1, y1, RGB(r, g, b)
End Sub

